-------------------------------------------------------------------------------
-- system_stub.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity system_stub is
  port (
    RS232_Uart_1_sout : out std_logic;
    RS232_Uart_1_sin : in std_logic;
    RESET : in std_logic;
    CLK_P : in std_logic;
    CLK_N : in std_logic;
    data_from_user2 : in std_logic_vector(31 downto 0);
    data_from_user0 : in std_logic_vector(31 downto 0);
    user_cs : out std_logic_vector(3 downto 0);
    user_rd : out std_logic;
    data_from_user1 : in std_logic_vector(31 downto 0);
    user_wr : out std_logic;
    data_to_user : out std_logic_vector(31 downto 0);
    user_clk : out std_logic;
    user_add : out std_logic_vector(11 downto 0);
    data_from_user3 : in std_logic_vector(31 downto 0)
  );
end system_stub;

architecture STRUCTURE of system_stub is

  component system is
    port (
      RS232_Uart_1_sout : out std_logic;
      RS232_Uart_1_sin : in std_logic;
      RESET : in std_logic;
      CLK_P : in std_logic;
      CLK_N : in std_logic;
      data_from_user2 : in std_logic_vector(31 downto 0);
      data_from_user0 : in std_logic_vector(31 downto 0);
      user_cs : out std_logic_vector(3 downto 0);
      user_rd : out std_logic;
      data_from_user1 : in std_logic_vector(31 downto 0);
      user_wr : out std_logic;
      data_to_user : out std_logic_vector(31 downto 0);
      user_clk : out std_logic;
      user_add : out std_logic_vector(11 downto 0);
      data_from_user3 : in std_logic_vector(31 downto 0)
    );
  end component;

 attribute BOX_TYPE : STRING;
 attribute BOX_TYPE of system : component is "user_black_box";

begin

  system_i : system
    port map (
      RS232_Uart_1_sout => RS232_Uart_1_sout,
      RS232_Uart_1_sin => RS232_Uart_1_sin,
      RESET => RESET,
      CLK_P => CLK_P,
      CLK_N => CLK_N,
      data_from_user2 => data_from_user2,
      data_from_user0 => data_from_user0,
      user_cs => user_cs,
      user_rd => user_rd,
      data_from_user1 => data_from_user1,
      user_wr => user_wr,
      data_to_user => data_to_user,
      user_clk => user_clk,
      user_add => user_add,
      data_from_user3 => data_from_user3
    );

end architecture STRUCTURE;

